<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getClient } from '../plugins/contentful';
import { CONTENT_TYPES } from '../common/content-types';
import { CropInfinityHero, NextStepAlt } from '~/components/common/index.vue';
import { getPageMetadata } from '~/common/meta';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  components: {
    CropInfinityHero,
    NextStepAlt,
  },
  async asyncData({ i18n }) {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': '3lZVlrGx5bPMftqa5OlABT',
        include: 5,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });

      const data = items[0].fields.pageContent;
      const metadata = items[0].fields.seoMetadata[0].fields;
      const doc = { ...metadata } as any;
      const [hero, cards] = data;

      //  Hero:
      doc.heading = {
        title: hero.fields.title,
        subtitle: hero.fields.description,
        primary_btn: {
          text: hero.fields.primaryCta.fields.text,
          url: hero.fields.primaryCta.fields.externalUrl,
          data_ga_name: hero.fields.primaryCta.fields.dataGaName,
          data_ga_location: hero.fields.primaryCta.fields.dataGaLocation,
        },
      };

      // Cards
      doc.cards = cards.fields;

      return { doc };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).doc,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div class="upgrade">
    <CropInfinityHero :data="doc.heading" />
    <SlpContainer>
      <div class="cards slp-mb-48">
        <SlpTypography variant="heading3-bold" tag="h2" class="slp-pb-32">
          {{ doc.cards.header }}
        </SlpTypography>
        <SlpTypography variant="body1" tag="p" class="slp-pb-32 card__text">
          {{ doc.cards.description }}
        </SlpTypography>
        <div class="card-container">
          <a
            v-for="item in doc.cards.card"
            :key="item.fields.name"
            :href="item.fields.button.fields.externalUrl"
            class="card card__hover"
            :data_ga_name="item.fields.button.fields.dataGaName"
            :data_ga_location="item.fields.button.fields.dataGaName"
          >
            <SlpTypography
              variant="body1-bold"
              tag="p"
              class="card__text slp-pb-8"
            >
              {{ item.fields.title }}
            </SlpTypography>
            <SlpTypography variant="body2" tag="p" class="slp-pb-16 card__text">
              {{ item.fields.description }}
            </SlpTypography>
            <SlpTypography
              tag="span"
              variant="body2-bold"
              class="card__learn-more"
              >{{ item.fields.button.fields.text }}
              <SlpIcon
                class="card__icon"
                name="chevron-lg-right"
                variant="product"
              />
            </SlpTypography>
          </a>
        </div>
      </div>
    </SlpContainer>
    <NextStepAlt />
  </div>
</template>

<style lang="scss" scoped>
:deep .sales-hero {
  height: unset;

  .slp-col-md-7 {
    flex: unset;
    max-width: unset;
    padding: $spacing-48 0;
  }
}

.card-container {
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(315px, 1fr));
  gap: $spacing-16;
}

.card {
  padding: $spacing-24;
  border-radius: $spacing-8;
  background: $color-surface-800;
  color: $color-text-300;
  position: relative;
  overflow: hidden;

  &__learn-more {
    position: relative;
    z-index: 2;
    display: flex;
    align-items: center;
    justify-content: flex-start;
    gap: $spacing-4;
    color: $color-text-300;
  }

  &__text {
    position: relative;
    z-index: 2;
  }

  &__hover {
    transition: border-radius 0.3s $interactive-ease;

    &:hover {
      border-radius: $spacing-8 $spacing-8 40px $spacing-8;

      .card__icon {
        transform: translateX($spacing-4);
      }
    }

    &::before {
      content: '';
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background: linear-gradient(
        90.62deg,
        rgba(199, 177, 254, 0.4) 0.69%,
        rgba(255, 212, 216, 0.4) 100%
      );
      opacity: 0;
      border-radius: $spacing-8;
      transition: all 0.3s $interactive-ease;
    }

    &:hover::before {
      border-radius: $spacing-8 $spacing-8 40px $spacing-8;
      opacity: 1;
    }
  }
}
</style>
